{% extends "base.html" %}
{% load static %}

{% block title %} Edit question {% endblock %}
{% block titleHeader %} Edit question {% endblock %}

{% block titleSubHeader %}
{{question_element.question}}
{% endblock %}

{% block libraries %}
<script src="https://cdn.jsdelivr.net/npm/editorjs-html@3.0.3/build/edjsHTML.js"></script>

<script src="{% static 'js/jquery.autocomplete.js' %}"></script>
<script src="{% static 'js/editorjs.js' %}"></script>
<script src="https://cdn.jsdelivr.net/npm/codex.editor.header@2.0.4/dist/bundle.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@editorjs/header@latest"></script><!-- Header -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/simple-image@latest"></script><!-- Image -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/delimiter@latest"></script><!-- Delimiter -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/list@latest"></script><!-- List -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/checklist@latest"></script><!-- Checklist -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/quote@latest"></script><!-- Quote -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/code@latest"></script><!-- Code -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/embed@latest"></script><!-- Embed -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/table@latest"></script><!-- Table -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/link@latest"></script><!-- Link -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/warning@latest"></script><!-- Warning -->

<script src="https://cdn.jsdelivr.net/npm/@editorjs/marker@latest"></script><!-- Marker -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/inline-code@latest"></script><!-- Inline Code -->
{% endblock %}

{% block content %}


<div class="container">
    {% if request.user.is_staff %}
    {% if message_saved %}
        <div class="alert alert-success alert-dismissible fade show" role="alert">
          {{ message_saved }}
          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
    {% endif %}

    <form id="add_question_form" method="POST">
    {% csrf_token %}
    <h1>Category</h1>
    <select class="form-select" aria-label="multiple select example" name="select_cat" id="select_cat">
        {% for cat in categories %}
            <option {% if cat.name == question_element.category.name %} selected {% endif %} value="{{cat.name}}">{{cat.name}}</option>
        {% endfor %}
    </select>
    <button type="button" class="btn btn-success mt-2"
                data-bs-toggle="modal"
                data-bs-target="#addCat">
            <i class="fas fa-plus"></i> Add category
    </button>

    <h1>Question</h1>
    <input type="text" class="form-control" id="question"
           name="question" value="{{question_element.question}}"
           onkeyup="stoppedTyping_question()">

    <h1>Position</h1>
    <input id="question_position" name="question_position"
           type="number" class="form-control" value="{{question_element.position}}">

    <h1>Response</h1>
    <div id="editorjs"></div>
    <input id="editorjs_content" name="editorjs_content" type="hidden"
           value="">

    <div class="d-grid gap-2 d-md-flex justify-content-md-end mt-3 me-2">
        <a type="button" class="btn btn-danger" href="{% url 'faq_list' %}">
            <i class="fas fa-times"></i> Cancel
        </a>
        <button type="submit" class="btn btn-primary"
                id="submit_question" name="edit_question"
                >
            <i class="fas fa-pen"></i> Edit
        </button>
    </div>

    </form>


    <div class="modal fade" id="addCat" tabindex="-1"
         aria-labelledby="addTag" aria-hidden="true">
        <div class="modal-dialog">

            <div class="modal-content">
                <form id="add_cat_form" method="POST">
                    <div class="modal-header">
                        <h5 class="modal-title">Add category </h5>
                        <button type="button" class="btn-close"
                                data-bs-dismiss="modal"
                                aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        {% csrf_token %}
                        <p><b>Name</b></p>
                        <input type="text" class="form-control" id="cat_name"
                               name="cat_name" onkeyup="stoppedTyping()">

                        <p><b>Position</b></p>
                        <input id="cat_position" name="cat_position"
                               type="number" class="form-control" value="1">
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                                data-bs-dismiss="modal">Close
                        </button>
                        <button type="submit" class="btn btn-primary"
                                id="submit_cat" name="create_cat"
                                disabled>
                            <i class="fas fa-plus"></i> Add
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    {% endif %}
</div>

<script>

  function stoppedTyping(){
        var l = document.getElementById('cat_name').value.length ;
        if(l > 0 ) {
            $("#submit_cat").prop("disabled", false);
        } else {
            $("#submit_cat").prop("disabled", true);
        }
  }


  // EDITOR JS
        var content_dim = 0
        var False = false;
        var True = true;

        var editor = new EditorJS({
          /**
           * Enable/Disable the read only mode
           */

          readOnly: false,

          /**
           * Wrapper of Editor
           */
          holder: 'editorjs',

          /**
           * Common Inline Toolbar settings
           * - if true (or not specified), the order from 'tool' property will be used
           * - if an array of tool names, this order will be used
           */
           inlineToolbar: ['link', 'marker', 'bold', 'italic'],
           inlineToolbar: true,

          /**
           * Tools list
           */
          tools: {
            /**
             * Each Tool is a Plugin. Pass them via 'class' option with necessary settings {@link docs/tools.md}
             */
            header: {
              class: Header,
              inlineToolbar: ['marker', 'link'],
              config: {
                placeholder: 'Header'
              },
              shortcut: 'CMD+SHIFT+H'
            },

            /**
             * Or pass class directly without any configuration
             */
            image: SimpleImage,

            list: {
              class: List,
              inlineToolbar: true,
              shortcut: 'CMD+SHIFT+L'
            },

            checklist: {
              class: Checklist,
              inlineToolbar: true,
            },

            quote: {
              class: Quote,
              inlineToolbar: true,
              config: {
                quotePlaceholder: 'Enter a quote',
                captionPlaceholder: 'Quote\'s author',
              },
              shortcut: 'CMD+SHIFT+O'
            },

            warning: Warning,

            marker: {
              class:  Marker,
              shortcut: 'CMD+SHIFT+M'
            },

            code: {
              class:  CodeTool,
              shortcut: 'CMD+SHIFT+C'
            },

            delimiter: Delimiter,

            inlineCode: {
              class: InlineCode,
              shortcut: 'CMD+SHIFT+C'
            },

            linkTool: LinkTool,

            embed: {
              class: Embed,
              inlineToolbar: true,
            },

            table: {
              class: Table,
              inlineToolbar: true,
              shortcut: 'CMD+ALT+T'
            },

          },


          /**
           * Initial Editor data
           */

           data: {{question_element.response | safe }} ,

          onReady: function(){
            editor.save()
            .then((savedData) => {
                document.getElementById("editorjs_content").value = JSON.stringify(savedData);
                content_dim = savedData["blocks"].length;
            })
            .catch((error) => {
              document.getElementById("check").innerHTML="Error";
                 setTimeout(function(){
                 document.getElementById("check").innerHTML="";
                 },3000);
            });
          },
          onChange: function() {
            editor.save()
            .then((savedData) => {
                document.getElementById("editorjs_content").value = JSON.stringify(savedData);
                content_dim = savedData["blocks"].length;
                var l = document.getElementById('question').value.length ;
                if(savedData["blocks"].length != 0 && l > 0){
                    $("#submit_question").prop("disabled", false);
                } else {
                    $("#submit_question").prop("disabled", true);
                }
            })
            .catch((error) => {
              document.getElementById("check").innerHTML="Error";
                 setTimeout(function(){
                 document.getElementById("check").innerHTML="";
                 },3000);
            });
          }
        });

      function stoppedTyping_question(){
        var l = document.getElementById('question').value.length ;
        if(l > 0 && content_dim >0) {
            $("#submit_question").prop("disabled", false);
        } else {
            $("#submit_question").prop("disabled", true);
        }
      }

      // Listen position input change
      const position_input = document.querySelector('input[name="question_position"]');
      position_input.addEventListener("change", (e) => {
        var l = document.getElementById('question').value.length ;
        if(l > 0 && content_dim >0){
            $("#submit_question").prop("disabled", false);
        } else {
            $("#submit_question").prop("disabled", true);
        }
      });



</script>
{% endblock %}